searchData={"items":[{"type":"module","doc":"","title":"AshDefaultSort","ref":"AshDefaultSort.html"},{"type":"macro","doc":"","title":"AshDefaultSort.default_sort/1","ref":"AshDefaultSort.html#default_sort/1"},{"type":"module","doc":"","title":"AshDefaultSort.Info","ref":"AshDefaultSort.Info.html"},{"type":"function","doc":"List of read actions to exclude","title":"AshDefaultSort.Info.default_sort_except/1","ref":"AshDefaultSort.Info.html#default_sort_except/1"},{"type":"function","doc":"List of read actions to exclude","title":"AshDefaultSort.Info.default_sort_except!/1","ref":"AshDefaultSort.Info.html#default_sort_except!/1"},{"type":"function","doc":"Whether to apply to the primary read action as well","title":"AshDefaultSort.Info.default_sort_include_primary_read?/1","ref":"AshDefaultSort.Info.html#default_sort_include_primary_read?/1"},{"type":"function","doc":"default_sort DSL options\n\nReturns a map containing the and any configured or default values.","title":"AshDefaultSort.Info.default_sort_options/1","ref":"AshDefaultSort.Info.html#default_sort_options/1"},{"type":"function","doc":"The sort to apply when Ash.Query has no sort","title":"AshDefaultSort.Info.default_sort_sort/1","ref":"AshDefaultSort.Info.html#default_sort_sort/1"},{"type":"function","doc":"The sort to apply when Ash.Query has no sort","title":"AshDefaultSort.Info.default_sort_sort!/1","ref":"AshDefaultSort.Info.html#default_sort_sort!/1"},{"type":"module","doc":"","title":"AshDefaultSort.Preparation","ref":"AshDefaultSort.Preparation.html"},{"type":"function","doc":"Callback implementation for  Ash.Resource.Preparation.init/1 .","title":"AshDefaultSort.Preparation.init/1","ref":"AshDefaultSort.Preparation.html#init/1"},{"type":"function","doc":"Callback implementation for  Ash.Resource.Preparation.prepare/3 .","title":"AshDefaultSort.Preparation.prepare/3","ref":"AshDefaultSort.Preparation.html#prepare/3"},{"type":"module","doc":"","title":"AshDefaultSort.Transformer","ref":"AshDefaultSort.Transformer.html"},{"type":"function","doc":"Callback implementation for  Spark.Dsl.Transformer.after?/1 .","title":"AshDefaultSort.Transformer.after?/1","ref":"AshDefaultSort.Transformer.html#after?/1"},{"type":"function","doc":"Callback implementation for  Spark.Dsl.Transformer.after_compile?/0 .","title":"AshDefaultSort.Transformer.after_compile?/0","ref":"AshDefaultSort.Transformer.html#after_compile?/0"},{"type":"function","doc":"Callback implementation for  Spark.Dsl.Transformer.before?/1 .","title":"AshDefaultSort.Transformer.before?/1","ref":"AshDefaultSort.Transformer.html#before?/1"},{"type":"function","doc":"Callback implementation for  Spark.Dsl.Transformer.transform/1 .","title":"AshDefaultSort.Transformer.transform/1","ref":"AshDefaultSort.Transformer.html#transform/1"},{"type":"extras","doc":"# AshDefaultSort\n\nConfigure a default sort to apply when a read action has no sort.","title":"AshDefaultSort","ref":"readme.html"},{"type":"extras","doc":"Add `ash_default_sort` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ash_default_sort, \"~> 0.1.0\"}\n  ]\nend\n```","title":"Installation - AshDefaultSort","ref":"readme.html#installation"},{"type":"extras","doc":"```elixir\ndefmodule Post do\n  use Ash.Resource,\n    data_layer: Ash.DataLayer.Postgres,\n    extensions: [AshDefaultSort]\n\n  actions do\n    read :read do\n      primary? true\n    end\n  \n    read :read_sorted do\n      prepare build(sort: [id: :desc])\n    end\n\n    read :read_all do\n    end\n\n    read :read_every do\n    end\n\n  default_sort do\n    sort [like_count: :desc, created_at: :desc]\n    include_primary_read? false\n    except [:read_all]\n  end\nend\n```\n\nIn the example above, [like_count: :desc, created_at: :desc] is applied to `read_every`.\n\nThis is because `read` is excluded by `include_primary_read? false`, `read_sorted` is not affected because it already includes a sort, and `read_all` is excluded by the `except` option.","title":"Usage - AshDefaultSort","ref":"readme.html#usage"},{"type":"extras","doc":"MIT","title":"License - AshDefaultSort","ref":"readme.html#license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.1"}}